Attribute VB_Name = "Code"
'   Program:  AntSiteDb -- Antenna Site Database

'    Author:  Donald Draper Campbell
'             Electronic Engineer
'             Federal Communications Commission
'             Office of Engineering and Technology
'             Spectrum Untilization and Ecomonics Branch
'             445 12th Street, SW, Room 7-A263
'             Washington, DC  20554    USA
'             e-mail:  donald.campbell@fcc.gov
'             Tele: +1 (202) 418-2405, 7:30a -> 4:00p, eastern time
'             e-mail:  cmpblldd@ix.netcom.com

'  This program is used to build the Antenna Site index tables for the assigment
'  database conversion programs: CnvCdbs, CnvCoals, CnvIbfs and CnvWtb

'SourceCode:  www.fcc.gov/oet/info/software

'  Language:  Microsoft VisualBASIC (Professional) version 6.0

Option Explicit

Public Const gtVersionDate = "Beta version 1.0.0  --  2008.07.25"

Sub Main()

    frmStatus.lblStatus.Caption = "In Main"
    frmStatus.lblDateTimeStart.Caption = Now
    frmStatus.Refresh
    
    giNewLineCharFlag = 1    '  YES, New Line character repair is needed
    'giNewLineCharFlag = 0    '   NO, New Line character repair is NOT needed

    giActionCounter = 0
    gtActionText = "Start AntSiteDb"
    glLengthOfFile = 0
    glRecCnt = 0

    Select Case giProcessAction

        Case Is = 0
            frmStatus.lblStatus.Caption = "Process not selected!"
            DoEvents
        
        Case Is = 1    ' Create ASR Raw Registration Database

            gtCompactMdbFile = gtInputDataPath & "tmpAsr.mdb"
    
            gtActionTextMsg = "Market:  "
            frmStatus.lblStatus.Caption = ""
            frmStatus.lblStepTotal.Caption = "6"
            frmStatus.Caption = "Processing the ASR Registration data set."

            giActionCounter = giActionCounter + 1
            frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
            frmStatus.Refresh
            Call CnvAsrTblRegCo

            giActionCounter = giActionCounter + 1
            frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
            frmStatus.Refresh
            Call CnvAsrTblRegEn

            giActionCounter = giActionCounter + 1
            frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
            frmStatus.Refresh
            Call CnvAsrTblRegHs

            giActionCounter = giActionCounter + 1
            frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
            frmStatus.Refresh
            Call CnvAsrTblRegRa

            giActionCounter = giActionCounter + 1
            frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
            frmStatus.Refresh
            Call CnvAsrTblRegRe

            giActionCounter = giActionCounter + 1
            frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
            frmStatus.Refresh
            Call CnvAsrTblRegSc

            If (Dir(LCase(gtInputDataPath & "datafile.tmp")) = "datafile.tmp") Then
                Kill (gtInputDataPath & "datafile.tmp")
            End If

            Call CreateAsrDataSet

            gtCompactDbMsg = "Compacting ASR database !"
            Call CompactDB

            frmStatus.ProgressBar1.Value = 0
            glLengthOfFile = 0
            glRecCnt = 0
            gtActionText = gtActionTextMsg & "Compacting database!"
            giActionCounter = giActionCounter + 1
            frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
            frmStatus.lblStatus.Caption = "Finished processing the Asr Market LICENSED data set!"
            frmStatus.Refresh

            Set wsJet = DBEngine.Workspaces(0)
            Set dbJet1 = wsJet.OpenDatabase(gtOutputMdbFile1)
            Set rsProcessLog = dbJet1.OpenRecordset("ProcessLog", dbOpenTable)
            Call WriteProcessLog

            rsProcessLog.Close
            Set rsProcessLog = Nothing

            dbJet1.Close
            Set dbJet1 = Nothing

            wsJet.Close
            Set wsJet = Nothing

        Case Is = 2    ' Create AntSite A, B, C & D Databases

        Case Is = 3    ' Update / Populate ASR Database

            Call PopulateAntSite_A

        Case Else

    End Select

End Sub    '  Main

Sub CreateAsrDataSet()

    Set wsJet = DBEngine.Workspaces(0)
    Set dbJet1 = wsJet.OpenDatabase(gtOutputMdbFile1)
    Set dbJet2 = wsJet.OpenDatabase(gtOutputMdbFile2)
    
    Set rsAntSiteOwner = dbJet2.OpenRecordset("AntSiteOwner", dbOpenTable)
    Set rsAntSiteInfo = dbJet2.OpenRecordset("AntSiteInfo", dbOpenTable)
    
    Set rsAsrCoTower = dbJet1.OpenRecordset("RegCoTower", dbOpenTable)
    Set rsAsrCoArray = dbJet1.OpenRecordset("RegCoArray", dbOpenTable)
    Set rsAsrRegEnO = dbJet1.OpenRecordset("RegEnO", dbOpenTable)
    Set rsAsrRegRa = dbJet1.OpenRecordset("RegRa", dbOpenTable)

    gtActionText = gtActionTextMsg & "CO Reg data!"
    Set rsProcessLog = dbJet1.OpenRecordset("ProcessLog", dbOpenTable)

    glRecCnt = 0
    glRecLen = 0

    gtSql = "SELECT RegEnO.FileNumber, RegEnO.ContentIndicator, " & _
            "RegEnO.EntityName, RegEnO.LastName, " & _
            "RegEnO.Frn, " & _
            "RegRa.StatusCode, " & _
            "RegEnO.State, RegEnO.City, RegEnO.PoBox, RegEnO.StreetAddress, " & _
            "RegRa.ArchiveFlagCode, " & _
            "RegRa.StructureStateCode, RegRa.StructureCity, " & _
            "RegCoArray.RegistrationNumberA, RegCoArray.CoordinateTypeA, " & _
            "RegCoArray.LatTotalSecA, RegCoArray.LonTotalSecA, " & _
            "RegCoTower.RegistrationNumberT, RegCoTower.CoordinateTypeT, " & _
            "RegCoTower.LatTotalSecT, RegCoTower.LonTotalSecT " & _
            "FROM ((RegEnO LEFT JOIN RegRa ON RegEnO.FileNumber = RegRa.FileNumber) LEFT JOIN RegCoArray ON RegRa.FileNumber = RegCoArray.FileNumberA) LEFT JOIN RegCoTower ON RegRa.FileNumber = RegCoTower.FileNumberT " & _
            "Where (((RegEnO.ContentIndicator) = " & Chr(34) & "REG" & Chr(34) & ") And " & _
            "((RegRa.StatusCode) = " & Chr(34) & "C" & Chr(34) & " Or " & _
            "(RegRa.StatusCode) = " & Chr(34) & "G" & Chr(34) & ") And " & _
            "((RegRa.ArchiveFlagCode) = " & Chr(34) & "C" & Chr(34) & ")) " & _
            "ORDER BY RegEnO.FileNumber"

    'MsgBox gtSql
    'DoEvents

    Set rsSQL = dbJet1.OpenRecordset(gtSql, dbOpenSnapshot)

    DoEvents
    rsSQL.MoveLast
    glNumRecs = rsSQL.RecordCount
    rsSQL.MoveFirst
    frmStatus.lblTotalRecords.Caption = Format(glNumRecs, "###,###,##0")
    frmStatus.Refresh
    DoEvents

    frmStatus.lblStatus.Caption = ""
    
    frmStatus.fraTotalRecords.Visible = True
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.fraFileSize.Visible = False
    frmStatus.fraAmtProcessed.Visible = False
    frmStatus.Refresh
    DoEvents

     Do While Not rsSQL.EOF

        glRecCnt = glRecCnt + 1
        If ((glRecCnt Mod 100) = 0) Then
            gsPercentComplete = (glRecCnt / glNumRecs) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            frmStatus.Refresh
        End If

        gtFileNumber = rsSQL!FileNumber

        gtFileNumberT = gtFileNumber
        Call DecodeAsrCoTower

        gtFileNumberA = gtFileNumber
        Call DecodeAsrCoArray
          'Call DecodeAsrEn

        Call DecodeAsrRegEnO
        Call DecodeAsrRA

        If (Len(gtFrn) > 0) Then
            gtStructureOwnerKey = gtFrn
        Else
            gtStructureOwnerKey = Mid(Trim(gtZipCode), 1, 5) & "-" & Trim(rsAsrRegEnO!FileNumber)
        End If

        Call WriteAntSiteOwnerTable

        If ((giTowerFlag = 1)) Then
            gtRegistrationNumberT = gtRegistrationNumber
            gtStructureOwnerKeyT = gtStructureOwnerKey
            Call WriteAntSiteInfoTableT
        End If

        If ((giArrayFlag = 1) And (giTowerFlag = 0)) Then
            gtRegistrationNumberA = gtRegistrationNumber
            gtStructureOwnerKeyA = gtStructureOwnerKey
            Call WriteAntSiteInfoTableA
            MsgBox ("Array only")
            DoEvents
        End If

        rsSQL.MoveNext

    Loop    '   rsSql

    gsPercentComplete = (glRecCnt / glNumRecs) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    frmStatus.lblStatus.Caption = "FINISHED building 'Lice' Table !"
    frmStatus.Refresh

    Call WriteProcessLog

    rsAntSiteOwner.Close
    Set rsAntSiteOwner = Nothing

    rsAntSiteInfo.Close
    Set rsAntSiteInfo = Nothing

    rsAsrCoTower.Close
    Set rsAsrCoTower = Nothing

    rsAsrCoArray.Close
    Set rsAsrCoArray = Nothing

    rsAsrRegEnO.Close
    Set rsAsrRegEnO = Nothing

    rsAsrRegRa.Close
    Set rsAsrRegRa = Nothing

    rsProcessLog.Close
    Set rsProcessLog = Nothing

    dbJet1.Close
    Set dbJet1 = Nothing
    
    dbJet2.Close
    Set dbJet2 = Nothing

    wsJet.Close
    Set wsJet = Nothing


End Sub    '  CreateAsrDataSet

Sub DecodeAsrCoTower()

    rsAsrCoTower.Index = "idxFileNumberT"    ' Define current index.
    rsAsrCoTower.Seek "=", gtFileNumberT
    If (Not rsAsrCoTower.NoMatch) Then
        gtRecordTypeT = rsAsrCoTower!RecordTypeT      ' Char(2)
        gtContentIndicatorT = rsAsrCoTower!ContentIndicatorT    ' Char(3)
        'gtFileNumberT = rsAsrCoTower!FileNumberT    ' Char(8)
        gtRegistrationNumberT = rsAsrCoTower!RegistrationNumberT    ' Char(7)
        glUniqueSystemIdentifierT = rsAsrCoTower!UniqueSystemIdentifierT    ' Numeric(9, 0)
        gtCoordinateTypeT = rsAsrCoTower!CoordinateTypeT    ' Char(1)
        giLatDegT = rsAsrCoTower!LatDegT    ' Int
        giLatMinT = rsAsrCoTower!LatMinT    ' Int
        gsLatSecT = rsAsrCoTower!LatSecT    ' Numeric(4, 1)
        gtLatDirT = rsAsrCoTower!LatDirT    ' Char(1)
        gdLatTotalSecT = rsAsrCoTower!LatTotalSecT  ' Numeric(8, 1)
        giLonDegT = rsAsrCoTower!LonDegT     ' Int
        giLonMinT = rsAsrCoTower!LonMinT    ' Int
        gsLonSecT = rsAsrCoTower!LonSecT    ' Numeric(4, 1)
        gtLonDirT = rsAsrCoTower!LonDirT    ' Char(1)
        gdLonTotalSecT = rsAsrCoTower!LonTotalSecT    ' Numeric(8, 1)
        giTowerFlag = 1
    Else
        gtRecordTypeT = ""
        gtContentIndicatorT = ""
        gtFileNumberT = "-1"
        gtRegistrationNumberT = ""
        glUniqueSystemIdentifierT = ""
        gtCoordinateTypeT = ""
        'giLatDegT = ""
        'giLatMinT = ""
        'gsLatSecT = ""
        'gtLatDirT = ""
        'gdLatTotalSecT = ""
        'giLonDegT = ""
        'giLonMinT = ""
        'gsLonSecT = ""
        'gtLonDirT = ""
        'gdLonTotalSecT = ""
        giTowerFlag = 1
        'MsgBox "AsrCoTower record not found"
        DoEvents
    End If

End Sub    '  DecodeAsrCoTower

Sub DecodeAsrCoArray()

    rsAsrCoArray.Index = "idxFileNumberA"    ' Define current index.
    rsAsrCoArray.Seek "=", gtFileNumberA
    If (Not rsAsrCoArray.NoMatch) Then
        gtRecordTypeA = rsAsrCoArray!RecordTypeA       ' Char(2)
        gtContentIndicatorA = rsAsrCoArray!ContentIndicatorA    ' Char(3)
        'gtFileNumberA = rsAsrCoArray!FileNumberA    ' Char(8)
        gtRegistrationNumberA = rsAsrCoArray!RegistrationNumberA    ' Char(7)
        glUniqueSystemIdentifierA = rsAsrCoArray!UniqueSystemIdentifierA   ' Numeric(9, 0)
        gtCoordinateTypeA = rsAsrCoArray!CoordinateTypeA    ' Char(1)
        giLatDegA = rsAsrCoArray!LatDegA   ' Int
        giLatMinA = rsAsrCoArray!LatMinA    ' Int
        gsLatSecA = rsAsrCoArray!LatSecA    ' Numeric(4, 1)
        gtLatDirA = rsAsrCoArray!LatDirA    ' Char(1)
        gdLatTotalSecA = rsAsrCoArray!LatTotalSecA  ' Numeric(8, 1)
        giLonDegA = rsAsrCoArray!LonDegA    ' Int
        giLonMinA = rsAsrCoArray!LonMinA    ' Int
        gsLonSecA = rsAsrCoArray!LonSecA    ' Numeric(4, 1)
        gtLonDirA = rsAsrCoArray!LonDirA    ' Char(1)
        gdLonTotalSecA = rsAsrCoArray!LonTotalSecA    ' Numeric(8, 1)
        giArrayFlag = 1
    Else
        gtRecordTypeA = ""
        gtContentIndicatorA = ""
        gtFileNumberA = "-1"
        gtRegistrationNumberA = ""
        glUniqueSystemIdentifierA = ""
        gtCoordinateTypeA = ""
        'giLatDegA = ""
        'giLatMinA = ""
        'gsLatSecA = ""
        'gtLatDirA = ""
        'gdLatTotalSecA = ""
        'giLonDegA = ""
        'giLonMinA = ""
        'gsLonSecA = ""
        'gtLonDirA = ""
        'gdLonTotalSecA = ""
        giArrayFlag = 0

        'MsgBox "AsrCoArray record not found"
        DoEvents
        
    End If

End Sub    '  DecodeAsrCoArray

Sub DecodeAsrRegEnO()

    rsAsrRegEnO.Index = "idxFileNumber"    ' Define current index.
    rsAsrRegEnO.Seek "=", gtFileNumber
    If (Not rsAsrRegEnO.NoMatch) Then
        gtRecordType = rsAsrRegEnO!RecordType    ' Char(2)
        gtContentIndicator = rsAsrRegEnO!ContentIndicator    ' Char(3)
        'gtFileNumber = rsAsrRegEnO!FileNumber    ' Char(8)
        gtRegistrationNumber = rsAsrRegEnO!RegistrationNumber    ' Char(7)
        glUniqueSystemIdentifier = rsAsrRegEnO!UniqueSystemIdentifier    ' Numeric(9, 0)
        gtEntityType = rsAsrRegEnO!EntityType    ' Char(1)
        gtLicenseeId = rsAsrRegEnO!LicenseeId    ' Char(9)
        gtEntityName = rsAsrRegEnO!EntityName    ' VarChar(200)
        gtFirstName = rsAsrRegEnO!FirstName    ' VarChar(20)
        gtMi = rsAsrRegEnO!mi    ' Char(1)
        gtLastName = rsAsrRegEnO!LastName    ' VarChar(20)
        gtSuffix = rsAsrRegEnO!Suffix    ' Char(3)
        gtPhone = rsAsrRegEnO!Phone    ' VarChar(10)
        gtInternetAddress = rsAsrRegEnO!InternetAddress    ' VarChar(50)
        gtStreetAddress = rsAsrRegEnO!StreetAddress     ' VarChar(35)
        gtPoBox = rsAsrRegEnO!PoBox    ' VarChar(20)
        gtCity = rsAsrRegEnO!City    ' VarChar(20)
        gtState = rsAsrRegEnO!State  ' Char(2)
        gtZipCode = rsAsrRegEnO!ZipCode    ' Char(9)
        gtAttention = rsAsrRegEnO!Attention  ' VarChar(35)
        gtFrn = rsAsrRegEnO!Frn     ' Char(10)
    Else
        MsgBox "AsrEn record not found"
        DoEvents
    End If

End Sub    '  DecodeAsrEn

Sub CnvAsrTblRegCo()

    'On Error GoTo ErrorCoReg

    Dim gtDataArray

    frmStatus.lblStatus.Caption = ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh
    If (LCase(Dir(gtInputDataPath & "co.dat")) <> "co.dat") Then
        frmStatus.lblStatus.Caption = " 'CO' data not found!  Exiting subroutine! "
        Exit Sub
    End If
    
    If (giNewLineCharFlag = 1) Then
        gtDataSet = "CO"
        giFF = FreeFile
        Open (gtInputDataPath & "co.dat") For Input As giFF
        glLengthOfFile = LOF(giFF)
        Call FixNewLineChar
        giFF = FreeFile
        Open (gtInputDataPath & "datafile.tmp") For Input As giFF
    Else
        giFF = FreeFile
        Open (gtInputDataPath & "co.dat") For Input As giFF
    End If
    
    frmStatus.lblStatus.Caption = "Processing 'CO' data !  Please wait . . . ."
    glLengthOfFile = LOF(giFF)
    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh

    Set wsJet = DBEngine.Workspaces(0)
    Set dbJet1 = wsJet.OpenDatabase(gtOutputMdbFile1)
    Set rsAsrCoTower = dbJet1.OpenRecordset("RegCoTower", dbOpenTable)
    Set rsAsrCoArray = dbJet1.OpenRecordset("RegCoArray", dbOpenTable)
    gtActionText = gtActionTextMsg & "CO Reg data!"
    Set rsProcessLog = dbJet1.OpenRecordset("ProcessLog", dbOpenTable)

    glRecCnt = 0
    glRecLen = 0
    
    giMaxFldCnt = 16

    Do While Not EOF(giFF)

        gtTempString = ""
        Line Input #giFF, gtInputData
        gtInputData = Trim(gtInputData)

        If (Len(gtInputData) = 0) Then GoTo TagCoReg
    
        If (giNewLineCharFlag = 0) Then
            'Call NewLineRepair
        End If
        
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        
        If (gtInputData = gtInputDataPre) Then GoTo TagCoReg

        gtDataArray = ""
        gtDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)


        If (Trim(gtDataArray(5)) = "T") Then
            BeginTrans
            rsAsrCoTower.AddNew
            rsAsrCoTower!RecordTypeT = Trim(gtDataArray(0))    ' Char(2)
            rsAsrCoTower!ContentIndicatorT = Trim(gtDataArray(1))    ' Char(3)
            rsAsrCoTower!FileNumberT = Trim(gtDataArray(2))    ' Char(8)
            rsAsrCoTower!RegistrationNumberT = Trim(gtDataArray(3))    ' Char(7)
            rsAsrCoTower!UniqueSystemIdentifierT = Trim(gtDataArray(4))    ' Numeric(9, 0)
            rsAsrCoTower!CoordinateTypeT = Trim(gtDataArray(5))    ' Char(1)
            rsAsrCoTower!LatDegT = Val(gtDataArray(6))    ' Int
            rsAsrCoTower!LatMinT = Val(gtDataArray(7))    ' Int
            rsAsrCoTower!LatSecT = Val(gtDataArray(8))    ' Numeric(4, 1)
            rsAsrCoTower!LatDirT = Trim(gtDataArray(9))    ' Char(1)
            If (Trim(gtDataArray(9)) = "S") Then
                rsAsrCoTower!LatTotalSecT = -1 * Val(gtDataArray(10))  ' Numeric(8, 1)
            Else
                rsAsrCoTower!LatTotalSecT = Val(gtDataArray(10))    ' Numeric(8, 1)
            End If
            rsAsrCoTower!LonDegT = Val(gtDataArray(11))    ' Int
            rsAsrCoTower!LonMinT = Val(gtDataArray(12))    ' Int
            rsAsrCoTower!LonSecT = Val(gtDataArray(13))    ' Numeric(4, 1)
            rsAsrCoTower!LonDirT = Trim(gtDataArray(14))    ' Char(1)
            If (Trim(gtDataArray(14)) = "E") Then
                rsAsrCoTower!LonTotalSecT = Val(gtDataArray(15))    ' Numeric(8, 1)
            Else
                rsAsrCoTower!LonTotalSecT = -1 * Val(gtDataArray(15))  ' Numeric(8, 1)
            End If
            rsAsrCoTower.Update
            CommitTrans
            DoEvents
        Else
            BeginTrans
            rsAsrCoArray.AddNew
            rsAsrCoArray!RecordTypeA = Trim(gtDataArray(0))    ' Char(2)
            rsAsrCoArray!ContentIndicatorA = Trim(gtDataArray(1))    ' Char(3)
            rsAsrCoArray!FileNumberA = Trim(gtDataArray(2))    ' Char(8)
            rsAsrCoArray!RegistrationNumberA = Trim(gtDataArray(3))    ' Char(7)
            rsAsrCoArray!UniqueSystemIdentifierA = Trim(gtDataArray(4))    ' Numeric(9, 0)
            rsAsrCoArray!CoordinateTypeA = Trim(gtDataArray(5))    ' Char(1)
            rsAsrCoArray!LatDegA = Val(gtDataArray(6))    ' Int
            rsAsrCoArray!LatMinA = Val(gtDataArray(7))    ' Int
            rsAsrCoArray!LatSecA = Val(gtDataArray(8))    ' Numeric(4, 1)
            rsAsrCoArray!LatDirA = Trim(gtDataArray(9))    ' Char(1)
            If (Trim(gtDataArray(9)) = "S") Then
                rsAsrCoArray!LatTotalSecA = -1 * Val(gtDataArray(10))  ' Numeric(8, 1)
            Else
                rsAsrCoArray!LatTotalSecA = Val(gtDataArray(10))    ' Numeric(8, 1)
            End If
            rsAsrCoArray!LonDegA = Val(gtDataArray(11))    ' Int
            rsAsrCoArray!LonMinA = Val(gtDataArray(12))    ' Int
            rsAsrCoArray!LonSecA = Val(gtDataArray(13))    ' Numeric(4, 1)
            rsAsrCoArray!LonDirA = Trim(gtDataArray(14))    ' Char(1)
            If (Trim(gtDataArray(14)) = "E") Then
                rsAsrCoArray!LonTotalSecA = Val(gtDataArray(15))    ' Numeric(8, 1)
            Else
                rsAsrCoArray!LonTotalSecA = -1 * Val(gtDataArray(15))  ' Numeric(8, 1)
            End If
            rsAsrCoArray.Update
            CommitTrans
            DoEvents
        End If

TagCoReg:
        gtInputDataPre = gtInputData
    
    Loop
        
    frmStatus.lblStatus.Caption = "FINISHED processing 'CO' data !"
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents
        
    Close

    Call WriteProcessLog

    rsAsrCoTower.Close
    Set rsAsrCoTower = Nothing
    rsAsrCoArray.Close
    Set rsAsrCoArray = Nothing
    dbJet1.Close
    Set dbJet1 = Nothing
    
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputDataPath & "co.dat" & "  >  data !" & vbCrLf & "  Step  1  of  12"
    'DoEvents
    
    Exit Sub
    
ErrorCoReg:
    
    gtMsg = "Error in polulating Asr Co table" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    MsgBox gtMsg


End Sub    '  CnvAsrTblRegCo

Sub CnvAsrTblRegEn()

    'On Error GoTo ErrorRegEn

    Dim gtDataArray

    frmStatus.lblStatus.Caption = ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh
    If (LCase(Dir(gtInputDataPath & "en.dat")) <> "en.dat") Then
        frmStatus.lblStatus.Caption = " 'EN' data not found!  Exiting subroutine! "
        Exit Sub
    End If
    
    If (giNewLineCharFlag = 1) Then
        gtDataSet = "EN"
        giFF = FreeFile
        Open (gtInputDataPath & "en.dat") For Input As giFF
        glLengthOfFile = LOF(giFF)
        Call FixNewLineChar
        giFF = FreeFile
        Open (gtInputDataPath & "datafile.tmp") For Input As giFF
    Else
        giFF = FreeFile
        Open (gtInputDataPath & "en.dat") For Input As giFF
    End If
    
    frmStatus.lblStatus.Caption = "Processing 'EN' data !  Please wait . . . ."
    glLengthOfFile = LOF(giFF)
    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh

    Set wsJet = DBEngine.Workspaces(0)
    Set dbJet1 = wsJet.OpenDatabase(gtOutputMdbFile1)
    Set rsAsrEnO = dbJet1.OpenRecordset("RegEnO", dbOpenTable)
    Set rsAsrEnR = dbJet1.OpenRecordset("RegEnR", dbOpenTable)
    gtActionText = gtActionTextMsg & "EN Reg data!"
    Set rsProcessLog = dbJet1.OpenRecordset("ProcessLog", dbOpenTable)

    glRecCnt = 0
    glRecLen = 0
    
    giMaxFldCnt = 21

    Do While Not EOF(giFF)

        gtTempString = ""
        Line Input #giFF, gtInputData
        gtInputData = Trim(gtInputData)

        If (Len(gtInputData) = 0) Then GoTo TagRegEn
    
        If (giNewLineCharFlag = 0) Then
            'Call NewLineRepair
        End If
        
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        
        If (gtInputData = gtInputDataPre) Then GoTo TagRegEn

        gtDataArray = ""
        gtDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)
        
        Select Case Trim(gtDataArray(5))
            Case Is = "O"
                BeginTrans
                rsAsrEnO.AddNew
                rsAsrEnO!RecordType = Trim(gtDataArray(0))    ' Char(2)
                rsAsrEnO!ContentIndicator = Trim(gtDataArray(1))    ' Char(3)
                rsAsrEnO!FileNumber = Trim(gtDataArray(2))       ' Char(8)
                rsAsrEnO!RegistrationNumber = Trim(gtDataArray(3))    ' Char(7)
                rsAsrEnO!UniqueSystemIdentifier = Trim(gtDataArray(4))    ' Numeric(9, 0)
                rsAsrEnO!EntityType = Trim(gtDataArray(5))    ' Char(1)
                rsAsrEnO!LicenseeId = Trim(gtDataArray(6))    ' Char(9)
                    rsAsrEnO!EntityName = ""    '  Initialize "Memo" field
                rsAsrEnO!EntityName.AppendChunk Trim(gtDataArray(7))    ' VarChar(200)
                rsAsrEnO!FirstName = Trim(gtDataArray(8))    ' VarChar(20)
                rsAsrEnO!mi = Trim(gtDataArray(9))    ' Char(1)
                rsAsrEnO!LastName = Trim(gtDataArray(10))    ' VarChar(20)
                rsAsrEnO!Suffix = Trim(gtDataArray(11))    ' Char(3)
                rsAsrEnO!Phone = Trim(gtDataArray(12))    ' VarChar(10)
                rsAsrEnO!InternetAddress = LCase(Trim(gtDataArray(13)))    ' VarChar(50)
                rsAsrEnO!StreetAddress = Trim(gtDataArray(14))    ' VarChar(35)
                rsAsrEnO!PoBox = Trim(gtDataArray(15))    ' VarChar(20)
                rsAsrEnO!City = Trim(gtDataArray(16))    ' VarChar(20)
                rsAsrEnO!State = Mid(Trim(gtDataArray(17)), 1, 2)  ' Char(2)
                rsAsrEnO!ZipCode = Trim(gtDataArray(18))    ' Char(9)
                rsAsrEnO!Attention = Mid(Trim(gtDataArray(19)), 1, 35)  ' VarChar(35)
                rsAsrEnO!Frn = Trim(gtDataArray(20))    ' Char(9)
                rsAsrEnO.Update
                CommitTrans
            Case Is = "R"
                BeginTrans
                rsAsrEnR.AddNew
                rsAsrEnR!RecordType = Trim(gtDataArray(0))    ' Char(2)
                rsAsrEnR!ContentIndicator = Trim(gtDataArray(1))    ' Char(3)
                rsAsrEnR!FileNumber = Trim(gtDataArray(2))    ' Char(8)
                rsAsrEnR!RegistrationNumber = Trim(gtDataArray(3))    ' Char(7)
                rsAsrEnR!UniqueSystemIdentifier = Trim(gtDataArray(4))    ' Numeric(9, 0)
                rsAsrEnR!EntityType = Trim(gtDataArray(5))    ' Char(1)
                rsAsrEnR!LicenseeId = Trim(gtDataArray(6))    ' Char(9)
                    rsAsrEnR!EntityName = ""    '  Initialize "Memo" field
                rsAsrEnR!EntityName.AppendChunk Trim(gtDataArray(7))    ' VarChar(200)
                rsAsrEnR!FirstName = Trim(gtDataArray(8))    ' VarChar(20)
                rsAsrEnR!mi = Trim(gtDataArray(9))    ' Char(1)
                rsAsrEnR!LastName = Trim(gtDataArray(10))    ' VarChar(20)
                rsAsrEnR!Suffix = Trim(gtDataArray(11))    ' Char(3)
                rsAsrEnR!Phone = Trim(gtDataArray(12))    ' VarChar(10)
                rsAsrEnR!InternetAddress = LCase(Trim(gtDataArray(13)))    ' VarChar(50)
                rsAsrEnR!StreetAddress = Trim(gtDataArray(14))    ' VarChar(35)
                rsAsrEnR!PoBox = Trim(gtDataArray(15))    ' VarChar(20)
                rsAsrEnR!City = Trim(gtDataArray(16))    ' VarChar(20)
                rsAsrEnR!State = Mid(Trim(gtDataArray(17)), 1, 2)  ' Char(2)
                rsAsrEnR!ZipCode = Trim(gtDataArray(18))    ' Char(9)
                rsAsrEnR!Attention = Mid(Trim(gtDataArray(19)), 1, 35)  ' VarChar(35)
                rsAsrEnR!Frn = Trim(gtDataArray(20))    ' Char(9)
                rsAsrEnR.Update
                CommitTrans
            Case Else
                MsgBox ("EntityType = " & Trim(gtDataArray(5)))
                DoEvents
        End Select

TagRegEn:
        gtInputDataPre = gtInputData
    
    Loop
        
    frmStatus.lblStatus.Caption = "FINISHED processing 'EN' data !"
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents
        
    Close

    Call WriteProcessLog

    rsAsrEnO.Close
    Set rsAsrEnO = Nothing
    rsAsrEnR.Close
    Set rsAsrEnR = Nothing
    dbJet1.Close
    Set dbJet1 = Nothing
    
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputDataPath & "en.dat" & "  >  data !" & vbCrLf & "  Step  1  of  12"
    'DoEvents
    
    Exit Sub
    
ErrorRegEn:
    
    gtMsg = "Error in polulating Asr En table" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    MsgBox gtMsg


End Sub    '   CnvAsrTblRegEn

Sub CnvAsrTblRegHs()

    'On Error GoTo ErrorRegHs

    Dim gtDataArray

    frmStatus.lblStatus.Caption = ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh
    If (LCase(Dir(gtInputDataPath & "hs.dat")) <> "hs.dat") Then
        frmStatus.lblStatus.Caption = " 'HS' data not found!  Exiting subroutine! "
        Exit Sub
    End If
    
    If (giNewLineCharFlag = 1) Then
        gtDataSet = "HS"
        giFF = FreeFile
        Open (gtInputDataPath & "hs.dat") For Input As giFF
        glLengthOfFile = LOF(giFF)
        Call FixNewLineChar
        giFF = FreeFile
        Open (gtInputDataPath & "datafile.tmp") For Input As giFF
    Else
        giFF = FreeFile
        Open (gtInputDataPath & "hs.dat") For Input As giFF
    End If
    
    frmStatus.lblStatus.Caption = "Processing 'HS' data !  Please wait . . . ."
    glLengthOfFile = LOF(giFF)
    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh

    Set wsJet = DBEngine.Workspaces(0)
    Set dbJet1 = wsJet.OpenDatabase(gtOutputMdbFile1)
    Set rsAsrHs = dbJet1.OpenRecordset("RegHs", dbOpenTable)
    gtActionText = gtActionTextMsg & "HS Reg data!"
    Set rsProcessLog = dbJet1.OpenRecordset("ProcessLog", dbOpenTable)

    glRecCnt = 0
    glRecLen = 0
    
    giMaxFldCnt = 7

    Do While Not EOF(giFF)

        gtTempString = ""
        Line Input #giFF, gtInputData
        gtInputData = Trim(gtInputData)

        If (Len(gtInputData) = 0) Then GoTo TagRegHs
    
        If (giNewLineCharFlag = 0) Then
            'Call NewLineRepair
        End If
        
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        
        If (gtInputData = gtInputDataPre) Then GoTo TagRegHs

        gtDataArray = ""
        gtDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)
        
        BeginTrans
        rsAsrHs.AddNew
        rsAsrHs!RecordType = Trim(gtDataArray(0))    ' Char(2)
        rsAsrHs!ContentIndicator = Trim(gtDataArray(1))    ' Char(3)
        rsAsrHs!FileNumber = Trim(gtDataArray(2))    ' Char(8)
        rsAsrHs!RegistrationNumber = Trim(gtDataArray(3))    ' Char(7)
        rsAsrHs!UniqueSystemIdentifier = Trim(gtDataArray(4))    ' Numeric(9, 0)
        rsAsrHs!Date = Mid(Trim(gtDataArray(5)), 7, 4) & Mid(Trim(gtDataArray(5)), 1, 2) & Mid(Trim(gtDataArray(5)), 4, 2)
        rsAsrHs!Description = Trim(gtDataArray(6))    ' VarChar(50)
        rsAsrHs.Update
        CommitTrans
            DoEvents

TagRegHs:
        gtInputDataPre = gtInputData
    
    Loop
        
    frmStatus.lblStatus.Caption = "FINISHED processing 'HS' data !"
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents
        
    Close

    Call WriteProcessLog

    rsAsrHs.Close
    Set rsAsrHs = Nothing
    dbJet1.Close
    Set dbJet1 = Nothing
    
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputDataPath & "hs.dat" & "  >  data !" & vbCrLf & "  Step  1  of  12"
    'DoEvents
    
    Exit Sub
    
ErrorRegHs:
    
    gtMsg = "Error in polulating Asr Hs table" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    MsgBox gtMsg


End Sub    '  CnvAsrTblRegHs

Sub CnvAsrTblRegRa()

    'On Error GoTo ErrorRegRa

    Dim gtDataArray

    frmStatus.lblStatus.Caption = ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh
    If (LCase(Dir(gtInputDataPath & "ra.dat")) <> "ra.dat") Then
        frmStatus.lblStatus.Caption = " 'RA' data not found!  Exiting subroutine! "
        Exit Sub
    End If

'giNewLineCharFlag = 1
    
    If (giNewLineCharFlag = 1) Then
        gtDataSet = "RA"
        giFF = FreeFile
        Open (gtInputDataPath & "ra.dat") For Input As giFF
        glLengthOfFile = LOF(giFF)
        Call FixNewLineChar
        giFF = FreeFile
        Open (gtInputDataPath & "datafile.tmp") For Input As giFF
    Else
        giFF = FreeFile
        Open (gtInputDataPath & "ra.dat") For Input As giFF
    End If
    
    frmStatus.lblStatus.Caption = "Processing 'RA' data !  Please wait . . . ."
    glLengthOfFile = LOF(giFF)
    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh

    Set wsJet = DBEngine.Workspaces(0)
    Set dbJet1 = wsJet.OpenDatabase(gtOutputMdbFile1)
    Set rsAsrRa = dbJet1.OpenRecordset("RegRa", dbOpenTable)
    gtActionText = gtActionTextMsg & "RA Reg data!"
    Set rsProcessLog = dbJet1.OpenRecordset("ProcessLog", dbOpenTable)

    glRecCnt = 0
    glRecLen = 0
    
    giMaxFldCnt = 38

    Do While Not EOF(giFF)

        gtTempString = ""
        Line Input #giFF, gtInputData
        gtInputData = Trim(gtInputData)

        If (Len(gtInputData) = 0) Then GoTo TagRegRa
    
        If (giNewLineCharFlag = 0) Then
            'Call NewLineRepair
        End If
        
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        
        If (gtInputData = gtInputDataPre) Then GoTo TagRegRa

        gtDataArray = ""
        gtDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)
        
        BeginTrans
        rsAsrRa.AddNew
        rsAsrRa!RecordType = Trim(gtDataArray(0))    ' Char(2)
        rsAsrRa!ContentIndicator = Trim(gtDataArray(1))    ' Char(3)
        rsAsrRa!FileNumber = Trim(gtDataArray(2))    ' Char(8)
        rsAsrRa!RegistrationNumber = Trim(gtDataArray(3))    ' Char(7)
        rsAsrRa!UniqueSystemIdentifier = Trim(gtDataArray(4))    ' Numeric(9, 0)
        rsAsrRa!ApplicationPurpose = Trim(gtDataArray(5))    ' Char(2)
        rsAsrRa!PreviousPurpose = Trim(gtDataArray(6))    ' Char(2)
        rsAsrRa!InputSourceCode = Trim(gtDataArray(7))    ' Char(1)
        rsAsrRa!StatusCode = Trim(gtDataArray(8))    ' Char(1)
        rsAsrRa!DateEntered = Mid(Trim(gtDataArray(9)), 7, 4) & Mid(Trim(gtDataArray(9)), 1, 2) & Mid(Trim(gtDataArray(9)), 4, 2)
        rsAsrRa!DateReceived = Mid(Trim(gtDataArray(10)), 7, 4) & Mid(Trim(gtDataArray(10)), 1, 2) & Mid(Trim(gtDataArray(10)), 4, 2)
        rsAsrRa!DateIssued = Mid(Trim(gtDataArray(11)), 7, 4) & Mid(Trim(gtDataArray(11)), 1, 2) & Mid(Trim(gtDataArray(11)), 4, 2)
        rsAsrRa!DateConstructed = Mid(Trim(gtDataArray(12)), 7, 4) & Mid(Trim(gtDataArray(12)), 1, 2) & Mid(Trim(gtDataArray(12)), 4, 2)
        rsAsrRa!DateDismantled = Mid(Trim(gtDataArray(13)), 7, 4) & Mid(Trim(gtDataArray(13)), 1, 2) & Mid(Trim(gtDataArray(13)), 4, 2)
        rsAsrRa!DateAction = Mid(Trim(gtDataArray(14)), 7, 4) & Mid(Trim(gtDataArray(14)), 1, 2) & Mid(Trim(gtDataArray(14)), 4, 2)
        rsAsrRa!ArchiveFlagCode = Trim(gtDataArray(15))    ' Char(1)
        rsAsrRa!Version = Val(gtDataArray(16))    ' Int
        rsAsrRa!SignatureFirstName = Trim(gtDataArray(17))    ' VarChar(20)
        rsAsrRa!SignatureMiddleInitial = Trim(gtDataArray(18))    ' Char(1)
        rsAsrRa!SignatureLastName = Trim(gtDataArray(19))    ' VarChar(20)
        rsAsrRa!SignatureSuffix = Trim(gtDataArray(20))    ' VarChar(3)
        rsAsrRa!SignatureTitle = Trim(gtDataArray(21))    ' VarChar(40)
        rsAsrRa!InvalidSignature = Trim(gtDataArray(22))    ' Char(1)
        rsAsrRa!StructureStreetAddress = Trim(gtDataArray(23))    ' VarChar(80)
        rsAsrRa!StructureCity = Trim(gtDataArray(24))    ' VarChar(20)
        rsAsrRa!StructureStateCode = Trim(gtDataArray(25))    ' Char(2)
        rsAsrRa!HeightOfStructure = Val(gtDataArray(26))    ' Numeric(5, 1)
        rsAsrRa!GroundElevation = Val(gtDataArray(27))    ' Numeric(6, 1)
        rsAsrRa!OverallHeightAboveGround = Val(gtDataArray(28))    ' Numeric(6, 1)
        rsAsrRa!OverallHeightAmsl = Val(gtDataArray(29))    ' Numeric(6, 1)
        rsAsrRa!StructureType = Trim(gtDataArray(30))    ' Char(6)
        rsAsrRa!DateFaaDeterminationIssued = Mid(Trim(gtDataArray(31)), 7, 4) & Mid(Trim(gtDataArray(31)), 1, 2) & Mid(Trim(gtDataArray(31)), 4, 2)
        rsAsrRa!FaaStudyNumber = Trim(gtDataArray(32))    ' VarChar(20)
        rsAsrRa!FaaCircularNumber = Trim(gtDataArray(33))    ' VarChar(10)
        rsAsrRa!SpecificationOption = Val(gtDataArray(34))    '      Int
        rsAsrRa!PaintingAndLighting = Trim(gtDataArray(35))    ' VarChar(100)
        rsAsrRa!FaaEmiFlag = Trim(gtDataArray(36))    ' Char(1)
        rsAsrRa!NepaFlag = Trim(gtDataArray(37))    ' Char(1)
        rsAsrRa.Update
        CommitTrans
        DoEvents

TagRegRa:
        gtInputDataPre = gtInputData
    
    Loop
        
    frmStatus.lblStatus.Caption = "FINISHED processing 'RA' data !"
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents
        
    Close

    Call WriteProcessLog

    rsAsrRa.Close
    Set rsAsrRa = Nothing
    dbJet1.Close
    Set dbJet1 = Nothing
    
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputDataPath & "ra.dat" & "  >  data !" & vbCrLf & "  Step  1  of  12"
    'DoEvents
    
    Exit Sub
    
ErrorRegRa:
    
    gtMsg = "Error in polulating Asr Ra table" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    MsgBox gtMsg

End Sub    '  CnvAsrTblRegRa

Sub CnvAsrTblRegRe()

    'On Error GoTo ErrorRegRe

    Dim gtDataArray

    frmStatus.lblStatus.Caption = ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh
    If (LCase(Dir(gtInputDataPath & "re.dat")) <> "re.dat") Then
        frmStatus.lblStatus.Caption = " 'RE' data not found!  Exiting subroutine! "
        Exit Sub
    End If

'giNewLineCharFlag = 1

    If (giNewLineCharFlag = 1) Then
        gtDataSet = "RE"
        giFF = FreeFile
        Open (gtInputDataPath & "re.dat") For Input As giFF
        glLengthOfFile = LOF(giFF)
        Call FixNewLineChar
        giFF = FreeFile
        Open (gtInputDataPath & "datafile.tmp") For Input As giFF
    Else
        giFF = FreeFile
        Open (gtInputDataPath & "re.dat") For Input As giFF
    End If
    
    frmStatus.lblStatus.Caption = "Processing 'RE' data !  Please wait . . . ."
    glLengthOfFile = LOF(giFF)
    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh

    Set wsJet = DBEngine.Workspaces(0)
    Set dbJet1 = wsJet.OpenDatabase(gtOutputMdbFile1)
    Set rsAsrRe = dbJet1.OpenRecordset("RegRe", dbOpenTable)
    gtActionText = gtActionTextMsg & "RE Reg data!"
    Set rsProcessLog = dbJet1.OpenRecordset("ProcessLog", dbOpenTable)

    glRecCnt = 0
    glRecLen = 0
    
    giMaxFldCnt = 9

    Do While Not EOF(giFF)

        gtTempString = ""
        Line Input #giFF, gtInputData
        gtInputData = Trim(gtInputData)

        If (Len(gtInputData) = 0) Then GoTo TagRegRe
    
        If (giNewLineCharFlag = 0) Then
            'Call NewLineRepair
        End If
        
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        
        If (gtInputData = gtInputDataPre) Then GoTo TagRegRe

        gtDataArray = ""
        gtDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)
        
        BeginTrans
        rsAsrRe.AddNew
        rsAsrRe!RecordType = Trim(gtDataArray(0))    ' Char(2)
        rsAsrRe!ContentIndicator = Trim(gtDataArray(1))    ' Char(3)
        rsAsrRe!FileNumber = Trim(gtDataArray(2))    ' Char(8)
        rsAsrRe!RegistrationNumber = Trim(gtDataArray(3))    ' Char(7)
        rsAsrRe!UniqueSystemIdentifier = Trim(gtDataArray(4))    ' Numeric(9, 0)
        rsAsrRe!RemarkType = Trim(gtDataArray(5))    ' Char(3)
        rsAsrRe!DateKeyed = Mid(Trim(gtDataArray(6)), 7, 4) & Mid(Trim(gtDataArray(6)), 1, 2) & Mid(Trim(gtDataArray(6)), 4, 2)
        rsAsrRe!SequenceNumber = Val(gtDataArray(7))    ' Int
            rsAsrRe!RemarkText = ""    '  Initialize "Memo" field
        rsAsrRe!RemarkText.AppendChunk Trim(gtDataArray(8))    ' VarChar(200)
        rsAsrRe.Update
        CommitTrans
            DoEvents

TagRegRe:
        gtInputDataPre = gtInputData
    
    Loop
        
    frmStatus.lblStatus.Caption = "FINISHED processing 'RE' data !"
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents
        
    Close

    Call WriteProcessLog

    rsAsrRe.Close
    Set rsAsrRe = Nothing
    dbJet1.Close
    Set dbJet1 = Nothing
    
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputDataPath & "re.dat" & "  >  data !" & vbCrLf & "  Step  1  of  12"
    'DoEvents
    
    Exit Sub
    
ErrorRegRe:
    
    gtMsg = "Error in polulating Asr Re table" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    MsgBox gtMsg

End Sub    '  CnvAsrTblRegRe

Sub CnvAsrTblRegSc()

    'On Error GoTo ErrorRegSc

    Dim gtDataArray

    frmStatus.lblStatus.Caption = ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh
    If (LCase(Dir(gtInputDataPath & "sc.dat")) <> "sc.dat") Then
        frmStatus.lblStatus.Caption = " 'SC' data not found!  Exiting subroutine! "
        Exit Sub
    End If

'giNewLineCharFlag = 1
    
    If (giNewLineCharFlag = 1) Then
        gtDataSet = "SC"
        giFF = FreeFile
        Open (gtInputDataPath & "sc.dat") For Input As giFF
        glLengthOfFile = LOF(giFF)
        Call FixNewLineChar
        giFF = FreeFile
        Open (gtInputDataPath & "datafile.tmp") For Input As giFF
    Else
        giFF = FreeFile
        Open (gtInputDataPath & "sc.dat") For Input As giFF
    End If
    
    frmStatus.lblStatus.Caption = "Processing 'SC' data !  Please wait . . . ."
    glLengthOfFile = LOF(giFF)
    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh

    Set wsJet = DBEngine.Workspaces(0)
    Set dbJet1 = wsJet.OpenDatabase(gtOutputMdbFile1)
    Set rsAsrSc = dbJet1.OpenRecordset("RegSc", dbOpenTable)
    gtActionText = gtActionTextMsg & "SC Reg data!"
    Set rsProcessLog = dbJet1.OpenRecordset("ProcessLog", dbOpenTable)

    glRecCnt = 0
    glRecLen = 0
    
    giMaxFldCnt = 8

    Do While Not EOF(giFF)

        gtTempString = ""
        Line Input #giFF, gtInputData
        gtInputData = Trim(gtInputData)

        If (Len(gtInputData) = 0) Then GoTo TagRegSc
    
        If (giNewLineCharFlag = 0) Then
            'Call NewLineRepair
        End If
        
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        
        If (gtInputData = gtInputDataPre) Then GoTo TagRegSc

        gtDataArray = ""
        gtDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)
        
        BeginTrans
        rsAsrSc.AddNew
        rsAsrSc!RecordType = Trim(gtDataArray(0))    ' Char(2)
        rsAsrSc!ContentIndicator = Trim(gtDataArray(1))    ' Char(3)
        rsAsrSc!FileNumber = Trim(gtDataArray(2))    ' Char(8)
        rsAsrSc!RegistrationNumber = Trim(gtDataArray(3))    ' Char(7)
        rsAsrSc!UniqueSystemIdentifier = Trim(gtDataArray(4))    ' Numeric(9, 0)
        rsAsrSc!DateKeyed = Mid(Trim(gtDataArray(5)), 7, 4) & Mid(Trim(gtDataArray(5)), 1, 2) & Mid(Trim(gtDataArray(5)), 4, 2)
        rsAsrSc!SequenceNumber = Trim(gtDataArray(6))    '  Int
            rsAsrSc!RemarkText = ""    '  Initialize "Memo" field
        rsAsrSc!RemarkText.AppendChunk Trim(gtDataArray(7))    ' VarChar(255)
        rsAsrSc.Update
        CommitTrans
            DoEvents

TagRegSc:
        gtInputDataPre = gtInputData
    
    Loop
        
    frmStatus.lblStatus.Caption = "FINISHED processing 'SC' data !"
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents
        
    Close

    Call WriteProcessLog

    rsAsrSc.Close
    Set rsAsrSc = Nothing
    dbJet1.Close
    Set dbJet1 = Nothing
    
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputDataPath & "sc.dat" & "  >  data !" & vbCrLf & "  Step  1  of  12"
    'DoEvents
    
    Exit Sub
    
ErrorRegSc:
    
    gtMsg = "Error in polulating Asr Sc table" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    MsgBox gtMsg

End Sub    '  CnvAsrTblRegSc

Sub CompactDB()

    'On Error GoTo CompactDB_Err

    Dim glLof1 As Long, glLof2 As Long
    Dim gtTempDatabaseName As String

    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giFF = FreeFile
    Open (gtOutputMdbFile1) For Input As giFF
    glLof1 = LOF(giFF)
    Close (giFF)
    
    gtMsg = gtCompactDbMsg & vbCrLf & _
            "Current database size (bytes):   " & Format(glLof1, "###,###,##0") & vbCrLf & _
            "Please wait . . . . "
            frmStatus.lblStatus.Caption = gtMsg
    frmStatus.Refresh
    
    If (Dir(LCase(gtCompactMdbFile)) <> "") Then
        Kill gtCompactMdbFile
    End If
    
    DBEngine.CompactDatabase gtOutputMdbFile1, gtCompactMdbFile, dbLangGeneral
    
    Kill gtOutputMdbFile1
    
    Name gtCompactMdbFile As gtOutputMdbFile1

    giFF = FreeFile
    Open (gtOutputMdbFile1) For Input As giFF
    glLof2 = LOF(giFF)
    Close (giFF)
    
    gtMsg = "Uncompressed file size: " & Format(glLof1, "###,###,##0") & vbCrLf & _
            "Compressed file size: " & Format(glLof2, "###,###,##0") & "  |  " & _
            "Compression ratio: " & Format(((1# - (glLof2 / glLof1)) * 100#), "0.0")
    frmStatus.lblStatus.Caption = gtMsg
    frmStatus.Refresh

    gtActionText = gtActionTextMsg & "Compressing database !"
    gxCurrentDateTime = Now
    glMdbSize = glLof2
    glLengthOfFile = 0
    glRecCnt = 0
    Set wsJet = DBEngine.Workspaces(0)
    Set dbJet1 = wsJet.OpenDatabase(gtOutputMdbFile1)
    Set rsProcessLog = dbJet1.OpenRecordset("ProcessLog", dbOpenTable)
    Call WriteProcessLog
    
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    
    dbJet1.Close
    Set dbJet1 = Nothing

    Exit Sub

CompactDB_Err:
    
    MsgBox Err.Description
    DoEvents

End Sub    '  CompactDB

Sub WriteProcessLog()
    
    Dim giMdbFF As Integer
    DoEvents
    gxCurrentDateTime = Now

    giMdbFF = FreeFile
    Open (gtOutputMdbFile1) For Input As giMdbFF
    glMdbSize = LOF(giMdbFF)
    Close giMdbFF
    DoEvents

    BeginTrans
    rsProcessLog.AddNew
    rsProcessLog!ActionCounter = giActionCounter
    rsProcessLog!ActionText = Mid(gtActionText, 1, 50)
    rsProcessLog!CurrentDateTime = gxCurrentDateTime
    rsProcessLog!MdbSize = glMdbSize
    rsProcessLog!InputFileSize = glLengthOfFile
    rsProcessLog!RecordsProcessed = glRecCnt
    rsProcessLog.Update
    CommitTrans
    DoEvents

End Sub    '  WriteProcessLog

Sub FixNewLineChar()

    'On Error GoTo FixNewLineCharErr
    
    '  Remove erraint NewLine characters from data set!
    
    frmStatus.lblStatus.Caption = "Removing erriant NewLine characters from the " & gtDataSet & " data !"
    
    glRecLen = 0
    glRecCnt = 0
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    frmStatus.Refresh
    
    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh

    giODFF = FreeFile
    Open (gtInputDataPath & "datafile.tmp") For Output As giODFF
    
    gtInputData = ""
    gtOutputData = ""
    
    Do While Not EOF(giFF)
        
        Line Input #giFF, gtInputData   ' Read line into variable.
        
        If (Len(Trim(gtInputData)) >= 1) Then  ' or   >= 1
            
            If (Mid(gtInputData, 1, 3) = gtDataSet & "|") Then

                'If (Len(gtOutputData) > 0) Then
                    Print #giODFF, Trim(gtOutputData)
                    gtOutputData = Trim(gtInputData)
                    'MsgBox "pause"
                    DoEvents
                'End If
                glRecCnt = glRecCnt + 1
                glRecLen = glRecLen + Len(gtOutputData)
                If ((glRecCnt Mod 100) = 0) Then
                    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
                    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
                    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
                    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
                    frmStatus.ProgressBar1.Value = gsPercentComplete
                    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
                    frmStatus.Refresh
                End If
                
            Else
                gtOutputData = gtOutputData & " {/n} " & Trim(gtInputData)
                'MsgBox "pause, \n"
                DoEvents
            End If
        
        End If
    
    Loop

    Print #giODFF, gtOutputData
    
    glRecCnt = glRecCnt + 1
                    
    glRecLen = glRecLen + Len(gtInputData)
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    frmStatus.Refresh
    DoEvents
   
    Close
    
    Exit Sub

FixNewLineCharErr:

    gtMsg = "Error in FixNewLineChar" & vbCrLf
    gtMsg = gtMsg & gtInputData & vbCrLf
    MsgBox gtMsg

End Sub    '  FixNewLineChar

Sub DecodeAsrRA()

    rsAsrRegRa.Index = "idxFileNumber"    ' Define current index.
    rsAsrRegRa.Seek "=", gtFileNumber
    If (Not rsAsrRegRa.NoMatch) Then
        gtRecordType = rsAsrRegRa!RecordType    ' Char(2)
        gtContentIndicator = rsAsrRegRa!ContentIndicator    ' Char(3)
        'gtFileNumber = rsAsrRegRa!FileNumber    ' Char(8)
        gtRegistrationNumber = rsAsrRegRa!RegistrationNumber     ' Char(7)
        glUniqueSystemIdentifier = rsAsrRegRa!UniqueSystemIdentifier    ' Numeric(9, 0)
        gtApplicationPurpose = rsAsrRegRa!ApplicationPurpose     ' Char(2)
        gtPreviousPurpose = rsAsrRegRa!PreviousPurpose    ' Char(2)
        gtInputSourceCode = rsAsrRegRa!InputSourceCode    ' Char(1)
        gtStatusCode = rsAsrRegRa!StatusCode    ' Char(1)
        gtDateEntered = rsAsrRegRa!DateEntered
        gtDateReceived = rsAsrRegRa!DateReceived
        gtDateIssued = rsAsrRegRa!DateIssued
        gtDateConstructed = rsAsrRegRa!DateConstructed
        gtDateDismantled = rsAsrRegRa!DateDismantled
        gtDateAction = rsAsrRegRa!DateAction
        gtArchiveFlagCode = rsAsrRegRa!ArchiveFlagCode
        gtVersion = rsAsrRegRa!Version     ' Int
        gtSignatureFirstName = rsAsrRegRa!SignatureFirstName     ' VarChar(20)
        gtSignatureMiddleInitial = rsAsrRegRa!SignatureMiddleInitial    ' Char(1)
        gtSignatureLastName = rsAsrRegRa!SignatureLastName     ' VarChar(20)
        gtSignatureSuffix = rsAsrRegRa!SignatureSuffix     ' VarChar(3)
        gtSignatureTitle = rsAsrRegRa!SignatureTitle     ' VarChar(40)
        gtInvalidSignature = rsAsrRegRa!InvalidSignature     ' Char(1)
        gtStructureStreetAddress = rsAsrRegRa!StructureStreetAddress     ' VarChar(80)
        gtStructureCity = rsAsrRegRa!StructureCity     ' VarChar(20)
        gtStructureStateCode = rsAsrRegRa!StructureStateCode     ' Char(2)
        gtHeightOfStructure = rsAsrRegRa!HeightOfStructure     ' Numeric(5, 1)
        gtGroundElevation = rsAsrRegRa!GroundElevation     ' Numeric(6, 1)
        gtOverallHeightAboveGround = rsAsrRegRa!OverallHeightAboveGround     ' Numeric(6, 1)
        gtOverallHeightAmsl = rsAsrRegRa!OverallHeightAmsl     ' Numeric(6, 1)
        gtStructureType = rsAsrRegRa!StructureType     ' Char(6)
        gtDateFaaDeterminationIssued = rsAsrRegRa!DateFaaDeterminationIssued
        gtFaaStudyNumber = rsAsrRegRa!FaaStudyNumber     ' VarChar(20)
        gtFaaCircularNumber = rsAsrRegRa!FaaCircularNumber     ' VarChar(10)
        gtSpecificationOption = rsAsrRegRa!SpecificationOption     '      Int
        gtPaintingAndLighting = rsAsrRegRa!PaintingAndLighting    ' VarChar(100)
        gtFaaEmiFlag = rsAsrRegRa!FaaEmiFlag     ' Char(1)
        gtNepaFlag = rsAsrRegRa!NepaFlag     ' Char(1)
    Else
        MsgBox "AsrRA record not found"
        DoEvents
    End If

End Sub    '  DecodeAsrRA


Sub WriteAntSiteOwnerTable()

    rsAntSiteOwner.Index = "idxStructureOwnerKey"    ' Define current index.
    rsAntSiteOwner.Seek "=", gtStructureOwnerKey
    If (rsAntSiteOwner.NoMatch) Then

        BeginTrans
        rsAntSiteOwner.AddNew
        rsAntSiteOwner!StructureOwnerKey = gtStructureOwnerKey    '  dbText, 20)
        'rsAntSiteOwner!GrpFrn = gt    '  dbLong)
        rsAntSiteOwner!FccRegNum = gtFrn    '  dbtext  15)
        'rsAntSiteOwner!LiceTin = gt    '  dbText, 10)
        If (Len(gtEntityName) > 0) Then
            rsAntSiteOwner!LiceName = Mid(gtEntityName, 1, 80)  '  dbText, 80)
        Else
            rsAntSiteOwner!LiceName = Trim(Trim(gtLastName) & ", " & Trim(gtFirstName) & Trim(gtMi))  '  dbText, 80)
        End If
        'rsAntSiteOwner!LiceDBA = gt    '  dbText, 40)
        'rsAntSiteOwner!LiceStreet2 = gt    '  dbText, 40)
        rsAntSiteOwner!LiceStreet1 = Trim(gtStreetAddress)    '  dbText, 60)
        rsAntSiteOwner!LicePOB = Trim(gtPoBox)    '  dbText, 40)
        rsAntSiteOwner!LiceCity = Trim(gtCity)    '  dbText, 20)
        rsAntSiteOwner!LiceState = Trim(gtState)    '  dbText, 2)
        rsAntSiteOwner!LiceZipCode = Trim(gtZipCode)    '  dbText, 10)
        rsAntSiteOwner!LiceCountry = "USA"    '  dbText, 5)
        rsAntSiteOwner!LicePhone = Trim(gtPhone)    '  dbText, 14)
        'rsAntSiteOwner!LiceFax = gt    '  dbText, 14)
        rsAntSiteOwner!LiceEmail = Trim(gtInternetAddress)    '  dbText, 50)
        rsAntSiteOwner!LiceAttn = Trim(gtAttention)    '  dbText, 35)
        'rsAntSiteOwner!LiceType = gt    '  dbText, 1)
        'rsAntSiteOwner!EntityType = gt    '  dbText, 2)
        rsAntSiteOwner.Update
        CommitTrans
        DoEvents

        'gtRecordType = rsAsrEn!RecordType    ' Char(2)
        'gtContentIndicator = rsAsrEn!ContentIndicator    ' Char(3)
        'gtFileNumber = rsAsrEn!FileNumber    ' Char(8)
        'gtRegistrationNumber = rsAsrEn!RegistrationNumber    ' asr no.   Char(7)
        'gtUniqueSystemIdentifier = rsAsrEn!UniqueSystemIdentifier    ' Numeric(9, 0)
        'gtEntityType = rsAsrEn!EntityType    ' Char(1)
        'gtLicenseeId = rsAsrEn!LicenseeId    ' Char(9)
        ' = rsAsrEn!EntityName    ' VarChar(200)
        ' = rsAsrEn!FirstName    ' VarChar(20)
        ' = rsAsrEn!mi    ' Char(1)
        ' = rsAsrEn!LastName    ' VarChar(20)
        'gtSuffix = rsAsrEn!Suffix    ' Char(3)
        ' = rsAsrEn!Phone    ' VarChar(10)
        ' = rsAsrEn!InternetAddress    ' VarChar(50)
        ' = rsAsrEn!StreetAddress     ' VarChar(35)
        ' = rsAsrEn!PoBox    ' VarChar(20)
        ' = rsAsrEn!City    ' VarChar(20)
        ' = rsAsrEn!State  ' Char(2)
        ' = rsAsrEn!ZipCode    ' Char(9)
        ' = rsAsrEn!Attention  ' VarChar(35)
        ' = rsAsrEn!Frn = Trim(gtDataArray(20))    ' Char(10)
    Else
        'MsgBox "Duplicate Lice Record entry"
        DoEvents
    End If

End Sub    '  WriteAntSiteOwnerTable

Sub WriteAntSiteInfoTableT()

    rsAntSiteInfo.Index = "idxAntSiteKey"    ' Define current index.
    rsAntSiteInfo.Seek "=", ("A" & Trim(gtRegistrationNumberT))
    If (rsAntSiteInfo.NoMatch) Then
        BeginTrans
        rsAntSiteInfo.AddNew
        rsAntSiteInfo!AntSiteKey = ("A" & Trim(gtRegistrationNumberT))     '  dbText, 20)
        '                                 gtStructureOwnerKey
        rsAntSiteInfo!StructureOwnerKey = gtStructureOwnerKeyT      '  dbText, 20)
        rsAntSiteInfo!TowerArrayFlag = gtCoordinateTypeT     '  dbText, 1)
        rsAntSiteInfo!TowerReg = gtRegistrationNumberT    '  dbText, 10)
        rsAntSiteInfo!StructureType = gtStructureType      '  dbText, 6)
        'rsAntSiteInfo!Name = gtStructureName    '  dbText, 20)
        rsAntSiteInfo!Street = gtStructureStreetAddress     '  dbText, 80)
        rsAntSiteInfo!City = gtStructureCity     '  dbText, 20)
        'rsAntSiteInfo!County = gt    '  dbText, 30)
        rsAntSiteInfo!State = gtStructureStateCode     '  dbText, 2)
        'rsAntSiteInfo!Country = gt    '  dbText, 5)
        'rsAntSiteInfo!FipsCode = gt    '  dbText, 5)
        rsAntSiteInfo!LatDMS = gtLatDirT & Format(giLatDegT, "000") & Format(giLatMinT, "00") & Format(gsLatSecT, "00.0")    '  dbText, 10)
        gtLatTotalSecT = Format(gdLatTotalSecT, "00000000.0;-000000.0;00000000.0")

        rsAntSiteInfo!LatSec = gtLatTotalSecT    '  dbText, 10)
        rsAntSiteInfo!LonDMS = gtLonDirT & Format(giLonDegT, "000") & Format(giLonMinT, "00") & Format(gsLonSecT, "00.0")      '  dbText, 10)
        gtLonTotalSecT = Format(gdLonTotalSecT, "00000000.0;-0000000.0;00000000.0")
        rsAntSiteInfo!LonSec = gtLonTotalSecT     '  dbText, 10)
        rsAntSiteInfo!HorizDatum = "NAD83"    '  dbText, 6)
        rsAntSiteInfo!Nepa = gtNepaFlag     '  dbText, 1)
        rsAntSiteInfo!GrEl = gtGroundElevation     '  dbText, 6)
        rsAntSiteInfo!HgtStructure = gtHeightOfStructure     '  dbText, 6)
        rsAntSiteInfo!HgtToTip = gtOverallHeightAboveGround      '  dbText, 6)
        'rsAntSiteInfo!HgtToTipAMSL = gtOverallHeightAmsl    '  dbText, 6)
        rsAntSiteInfo.Update
        CommitTrans
        DoEvents
    Else
'        MsgBox "Duplicate Site Info Record entry"
'        DoEvents
    End If

End Sub    '  WriteAntSiteInfoTableT

Sub WriteAntSiteInfoTableA()

    rsAntSiteInfo.Index = "idxAntSiteKey"    ' Define current index.
    rsAntSiteInfo.Seek "=", ("A" & Trim(gtRegistrationNumberA))
    If (rsAntSiteInfo.NoMatch) Then
        BeginTrans
        rsAntSiteInfo.AddNew
        rsAntSiteInfo!AntSiteKey = (Trim(gtRegistrationNumberA))    '  dbText, 20)
        '                                 gtStructureOwnerKey
        rsAntSiteInfo!StructureOwnerKey = gtStructureOwnerKeyA    '  dbText, 20)
        rsAntSiteInfo!TowerArrayFlag = gtCoordinateTypeA    '  dbText, 1)
        rsAntSiteInfo!TowerReg = gtRegistrationNumberA    '  dbText, 10)
        rsAntSiteInfo!StructureType = gtStructureType     '  dbText, 6)
        'rsAntSiteInfo!Name = gtStructureName    '  dbText, 20)
        rsAntSiteInfo!Street = gtStructureStreetAddress     '  dbText, 80)
        rsAntSiteInfo!City = gtStructureCity     '  dbText, 20)
        'rsAntSiteInfo!County = gt    '  dbText, 30)
        rsAntSiteInfo!State = gtStructureStateCode     '  dbText, 2)
        'rsAntSiteInfo!Country = gt    '  dbText, 5)
        'rsAntSiteInfo!FipsCode = gt    '  dbText, 5)
        rsAntSiteInfo!LatDMS = gtLatDirA & Format(giLatDegA, "000") & Format(giLatMinA, "00") & Format(gsLatSecA, "00.0")    '  dbText, 10)
        rsAntSiteInfo!LatSec = gdLatTotalSecA    '  dbText, 10)
        rsAntSiteInfo!LonDMS = gtLonDirA & Format(giLonDegA, "000") & Format(giLonMinA, "00") & Format(gsLonSecA, "00.0")     '  dbText, 10)
        rsAntSiteInfo!LonSec = gdLonTotalSecA     '  dbText, 10)
        rsAntSiteInfo!HorizDatum = "NAD83"    '  dbText, 6)
        rsAntSiteInfo!Nepa = gtNepaFlag     '  dbText, 1)
        rsAntSiteInfo!GrEl = gtGroundElevation     '  dbText, 6)
        rsAntSiteInfo!HgtStructure = gtHeightOfStructure     '  dbText, 6)
        rsAntSiteInfo!HgtToTip = gtOverallHeightAboveGround      '  dbText, 6)
        'rsAntSiteInfo!HgtToTipAMSL = gtOverallHeightAmsl    '  dbText, 6)
        rsAntSiteInfo.Update
        CommitTrans
        DoEvents
    Else
'        MsgBox "Duplicate Site Info Record entry"
'        DoEvents
    End If

        'gtRecordType = rsAsrCoTower!RecordType      ' Char(2)
        'gtContentIndicator = rsAsrCoTower!ContentIndicator    ' Char(3)
        'gtFileNumber = rsAsrCoTower!FileNumber    ' Char(8)
        ' = rsAsrCoTower!RegistrationNumber    ' Char(7)
        'gtUniqueSystemIdentifier = rsAsrCoTower!UniqueSystemIdentifier    ' Numeric(9, 0)
        ' = rsAsrCoTower!CoordinateType    ' Char(1)
        ' = rsAsrCoTower!LatDeg    ' Int
        ' = rsAsrCoTower!LatMin    ' Int
        ' = rsAsrCoTower!LatSec    ' Numeric(4, 1)
        ' = rsAsrCoTower!LatDir    ' Char(1)
        ' = rsAsrCoTower!LatTotalSec  ' Numeric(8, 1)
        ' = rsAsrCoTower!LonDeg     ' Int
        ' = rsAsrCoTower!LonMin    ' Int
        ' = rsAsrCoTower!LonSec    ' Numeric(4, 1)
        ' = rsAsrCoTower!LonDir    ' Char(1)
        ' = rsAsrCoTower!LonTotalSec    ' Numeric(8, 1)

        ' = =
        'gtRecordType = rsAsrRa!RecordType    ' Char(2)
        'gtContentIndicator = rsAsrRa!ContentIndicator    ' Char(3)
        'gtFileNumber = rsAsrRa!FileNumber    ' Char(8)
        ' = rsAsrRa!RegistrationNumber     ' Char(7)
        'gtUniqueSystemIdentifier = rsAsrRa!UniqueSystemIdentifier    ' Numeric(9, 0)
        'gtApplicationPurpose = rsAsrRa!ApplicationPurpose     ' Char(2)
        'gtPreviousPurpose = rsAsrRa!PreviousPurpose    ' Char(2)
        'gtInputSourceCode = rsAsrRa!InputSourceCode    ' Char(1)
        'gtStatusCode = rsAsrRa!StatusCode    ' Char(1)
        'gtDateEntered = rsAsrRa!DateEntered
        'gtDateReceived = rsAsrRa!DateReceived
        'gtDateIssued = rsAsrRa!DateIssued
        'gtDateConstructed = rsAsrRa!DateConstructed
        'gtDateDismantled = rsAsrRa!DateDismantled
        'gtDateAction = rsAsrRa!DateAction
        'gtArchiveFlagCode = rsAsrRa!ArchiveFlagCode
        'gtVersion = rsAsrRa!Version     ' Int
        'gtSignatureFirstName = rsAsrRa!SignatureFirstName     ' VarChar(20)
        'gtSignatureMiddleInitial = rsAsrRa!SignatureMiddleInitial    ' Char(1)
        'gtSignatureLastName = rsAsrRa!SignatureLastName     ' VarChar(20)
        'gtSignatureSuffix = rsAsrRa!SignatureSuffix     ' VarChar(3)
        'gtSignatureTitle = rsAsrRa!SignatureTitle     ' VarChar(40)
        'gtInvalidSignature = rsAsrRa!InvalidSignature     ' Char(1)
        ' = rsAsrRa!StructureStreetAddress     ' VarChar(80)
        ' = rsAsrRa!StructureCity     ' VarChar(20)
        ' = rsAsrRa!StructureStateCode     ' Char(2)
        ' = rsAsrRa!HeightOfStructure     ' Numeric(5, 1)
        ' = rsAsrRa!GroundElevation     ' Numeric(6, 1)
        ' = rsAsrRa!OverallHeightAboveGround     ' Numeric(6, 1)
        ' = rsAsrRa!OverallHeightAmsl     ' Numeric(6, 1)
        ' = rsAsrRa!StructureType     ' Char(6)
        'gtDateFaaDeterminationIssued = rsAsrRa!DateFaaDeterminationIssued
        'gtFaaStudyNumber = rsAsrRa!FaaStudyNumber     ' VarChar(20)
        'gtFaaCircularNumber = rsAsrRa!FaaCircularNumber     ' VarChar(10)
        'gtSpecificationOption = rsAsrRa!SpecificationOption     '      Int
        'gtPaintingAndLighting = rsAsrRa!PaintingAndLighting    ' VarChar(100)
        'gtFaaEmiFlag = rsAsrRa!FaaEmiFlag     ' Char(1)
        ' = rsAsrRa!NepaFlag     ' Char(1)

End Sub    '  WriteAntSiteInfoTableA

Sub PopulateAntSite_A()

    Const Attr_Normal = 0

    frmAntSiteDb.Refresh
    frmStatus.Show
    frmStatus.Refresh

    frmStatus.lblStatus.Caption = "Processing 'LO - Ant Site A' data !  Please wait . . . ."
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.lblStatus.Caption = "Populating Ant Site A Database"
    frmStatus.Refresh



    gtFilename = LCase$(Dir$(gtOutputMdbFile1, Attr_Normal))
    giPos = InStr(1, gtOutputMdbFile1, gtFilename, 1)
    gtOutputMdbFile2 = Trim(Mid(gtOutputMdbFile1, 1, (giPos - 1))) & "antsitedb.mdb"

    'giPos = InStr(1, gtOutputMdbFile1, gtFilename, 1)
    'gtOutputMdbFile3 = Trim(Mid(gtOutputMdbFile1, 1, (giPos - 1))) & "antsite_a.mdb"

 
    ' = = = = =
    
    Set wsJet = DBEngine.Workspaces(0)
    
    Set dbJet1 = wsJet.OpenDatabase(gtOutputMdbFile1)    '  AsrDb
    Set rsProcessLog = dbJet1.OpenRecordset("ProcessLog", dbOpenTable)
    
    Set dbJet2 = wsJet.OpenDatabase(gtOutputMdbFile2)    '  AntSiteDb
    Set rsAntSiteInfo = dbJet2.OpenRecordset("AntSiteInfo", dbOpenTable)
    
    Set dbJet3 = wsJet.OpenDatabase(gtTwrLocMdbFileA)    '  AntSite_A
    Set rsAntSite_A = dbJet3.OpenRecordset("AntSite_A", dbOpenTable)
    
    'gtSql = "SELECT AntSiteInfo.AntSiteKey, AntSiteInfo.LatDMS, AntSiteInfo.LonDMS " & _
            "From AntSiteInfo " & _
            "ORDER BY AntSiteInfo.AntSiteKey"
    
    gtSql = "SELECT AntSiteInfo.AntSiteKey, AntSiteInfo.LatDMS, AntSiteInfo.LonDMS, AntSiteInfo.TowerReg " & _
            "From AntSiteInfo " & _
            "ORDER BY AntSiteInfo.AntSiteKey"

    'MsgBox gtSql
    'DoEvents
    
    Set rsSQL = dbJet2.OpenRecordset(gtSql, dbOpenSnapshot)
    
    rsSQL.MoveLast
    glNumRecs = rsSQL.RecordCount
    rsSQL.MoveFirst
    frmStatus.lblTotalRecords.Caption = Format(glNumRecs, "###,###,##0")

    '  Open database

    glRecCnt = 0

    Do While Not rsSQL.EOF

        glRecCnt = glRecCnt + 1
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glNumRecs, "###,###,##0")
            gsPercentComplete = (glRecCnt / glNumRecs) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If

            rsAntSite_A.Index = "idxTowerRegA"
            rsAntSite_A.Seek "=", (Trim(rsSQL!TowerReg))
            If (rsAntSite_A.NoMatch) Then
                '  Create a record
                BeginTrans
                rsAntSite_A.AddNew
                rsAntSite_A!TowerSiteKeyA = Trim(rsSQL!AntSiteKey)
                rsAntSite_A!TowerSiteInfoA = Trim(rsSQL!LatDMS) & "|" & Trim(rsSQL!LonDMS) & "|NAD83"
                rsAntSite_A!TowerRegA = Trim(rsSQL!TowerReg)    'dbText, 10)
                'rsAntSite_A!AntSite_CountA = 1   ' dbInteger
                rsAntSite_A.Update
                CommitTrans
                DoEvents
            Else
                'MsgBox "Dupicate Record"
                'DoEvents
            End If

        rsSQL.MoveNext

    Loop

    frmStatus.lblStatus.Caption = "FINISHED processing 'LO - Ant Site A' data !"

            frmStatus.lblAmtProcessed.Caption = Format(glNumRecs, "###,###,##0")
            gsPercentComplete = (glRecCnt / glNumRecs) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
    DoEvents

    Close

    Call WriteProcessLog

    dbJet1.Close
    Set dbJet1 = Nothing
    
    dbJet2.Close
    Set dbJet2 = Nothing
    
    dbJet3.Close
    Set dbJet3 = Nothing

    wsJet.Close
    Set wsJet = Nothing

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtTwrLocMdbFileA & "  >  data !" & vbCrLf & "  Step  1  of  12"
    'DoEvents


End Sub    '  PopulateTawerA

